function [tr2 T D] = pcaAnalysis2(sed,ncolorsArray, plotting)
% Simple SVD decomposition of sed using ncolorArray for plotting
% author: Mijail Guillemard September 2006

returnFast = 0; 
if nargin < 3; plotting = 0; end;
if nargin < 2; returnFast = 1; end; 
% 3d pca projection of data in sed 
% author: Mijail Guillemard June 2006
% parameters: 
% sed: matrix data, number of rows: n is a data section
% ncolorsArray is a array of size n with the color indexes

nv = 1; 

if size(sed,2) < 2; disp('Problem with pcaAnalysis!'); keyboard; end;
if size(sed,2) < 3; sed(:,3) = 0; end;

sedA = sed; 
sed = sed - repmat(mean(sed),size(sed,1),1);
sed = sed/norm(sed); % disp('withNormScaling'); 

[U,D,V] = svd(sed,0); 
nic = 3; T = D(1:nic,:)*V'; 
% nic = 3; T = (D(1:nic,:)>0)*V'; disp('new without D');
tr2 = sed*T';
ak = tr2(:,1); bk = tr2(:,2); ck = tr2(:,3);
% figure(11); plot3(ak,bk,ck,'r.'); grid on; rotate3d on;
% figure(12); plot(ak,bk,'r.'); grid on;

if returnFast == 1; return; end; 

ncolors = max(ncolorsArray);

% ===============
% set the colors 
if ncolors > 8; 
Colrs = [0 0 0.5625;0 0 0.625;0 0 0.6875;0 0 0.75;0 0 0.8125;0 0 0.875;0 0 0.9375;0 0 1;0 0.0625 1;0 0.125 1;0 0.1875 1;0 0.25 1;0 0.3125 1;0 0.375 1;0 0.4375 1;0 0.5 1;0 0.5625 1;0 0.625 1;0 0.6875 1;0 0.75 1;0 0.8125 1;0 0.875 1;0 0.9375 1;0 1 1;0.0625 1 1;0.125 1 0.9375;0.1875 1 0.875;0.25 1 0.8125;0.3125 1 0.75;0.375 1 0.6875;0.4375 1 0.625;0.5 1 0.5625;0.5625 1 0.5;0.625 1 0.4375;0.6875 1 0.375;0.75 1 0.3125;0.8125 1 0.25;0.875 1 0.1875;0.9375 1 0.125;1 1 0.0625;1 1 0;1 0.9375 0;1 0.875 0;1 0.8125 0;1 0.75 0;1 0.6875 0;1 0.625 0;1 0.5625 0;1 0.5 0;1 0.4375 0;1 0.375 0;1 0.3125 0;1 0.25 0;1 0.1875 0;1 0.125 0;1 0.0625 0;1 0 0;0.9375 0 0;0.875 0 0;0.8125 0 0;0.75 0 0;0.6875 0 0;0.625 0 0;0.5625 0 0];
Colrs(:,1) = 0.7*Colrs(:,1);
else
Colrs = [1,0,0; 0,1,0; 0,0,1; 0.5,0.5,0.5; 1,0,1; 0,1,1; 0.5,0.5,1; 1,1,0; 0,0.5,0];end;

% ===============
% plotting PCA 
if plotting == 1
  % disp('plotting'); 
  ak = tr2(:,1); bk = tr2(:,2); ck = tr2(:,3);
  la = length(ak); ak = ak(nv:la); bk = bk(nv:la); ck = ck(nv:la);
  lak=length(ak); pcks = lak/ncolors; 
  hold on; 
  for k=1:ncolors; 
	 inta = round(pcks*(k-1)+1); intb = round(pcks*k); 
	 intv = inta:intb;
	 colrs = Colrs(k,:);
	 plot3(ak(intv),bk(intv),ck(intv),'.','Color',colrs); 
  end;
  % intv = 240:260; aak = ak(intv); bbk = bk(intv); cck = ck(intv); 
  % plot3(aak,bbk,cck);
  grid on; % rotate3d on; 
  hold off; 
  colormap(Colrs);
end;

fname = 'pcaAnalysis';
% disp('pcaAnalysis'); keyboard; 

% for visualizing the colors in the Colrs array type
% colormap(Colrs) and set the colormap toolbar in the figure
% Colrs = [1,0,0; 0,1,0; 0,0,1; 0.5,0.5,0.5; 1,0,1; 0,1,1; 0.5,0.5,1; 1,1,0; 0,0.5,0];
