# Computes the persistence diagram of the alpha shapes in both 2D and 3D 
# (decided dynamically based on the input file)

import sys
sys.path.append("/home/mgy/prj/convolution/mfiles/Dionysus/build/bindings/python/")

from    dionysus        import Filtration, StaticPersistence, data_dim_cmp, vertex_cmp, \
                               fill_alpha3D_complex, fill_alpha2D_complex, points_file
from    sys             import argv, exit
from    math            import sqrt

def alphashapesEx(fileName):

    print 12

    #if len(argv) < 2:
    #    print "Usage: %s POINTS" % argv[0]
    #    exit()
        
    # points = [p for p in points_file(argv[1])]
    points = [p for p in points_file(fileName)]
    ftr = Filtration()
    if   len(points[0]) == 2:           # 2D
        fill_alpha2D_complex(points, ftr)
    elif len(points[1]) == 3:           # 3D
        fill_alpha3D_complex(points, ftr)
        
    print "Total number of simplices:", len(f)
        
    ftr.sort(data_dim_cmp)
    print "Filtration initialized"
    
    psp = StaticPersistence(ftr)
    print "StaticPersistence initialized" 
    
    psp.pair_simplices()
    print "Simplices paired"
        
    fil = open(fileName+'Pers','w')

    print "Outputting persistence diagram"
    smap = psp.make_simplex_map(ftr)
    for i in psp:
        if i.sign():
            b = smap[i]
            if i.unpaired():
                fil.write(str(b.dimension()) + " " + str(sqrt(b.data[0])) + " " + "inf" + "\n")
                        #print b.dimension(), sqrt(b.data[0]), "inf"
                continue
            
            d = smap[i.pair()]
            fil.write(str(b.dimension()) + " " + str(sqrt(b.data[0])) + " " + str(sqrt(d.data[0])) + "\n")
        #print b.dimension(), sqrt(b.data[0]), sqrt(d.data[0])

            
    fil.close()
