import re


textstring = """% ------------------------------------------------------------------------
\\begin{frame}[plain,fragile] 

\\begin{pgfpicture}{0cm}{0cm}{4cm}{6cm}
  {\pgfputat{\pgfxy(-1.5,-2.0)}{\includegraphics[scale=0.6]{sim1/freqBandsManifold10}}} 
  {\pgfputat{\pgfxy(4.7,-1.0)}{\includegraphics[scale=0.25]{sim2/tr2File10PersPlot1}}}  {\pgfputat{\pgfxy(8.2,-1.0)}{\includegraphics[scale=0.25]{sim2/tr2File10PersPlot2}}} 

  {\pgfputat{\pgfxy(0.0,6.85)}{$Function \; f=(1-\\alpha)g+\\alpha h$}}
  {\pgfputat{\pgfxy(0.6,6.55)}{$\small{\\alpha = xfj}$}}
  {\pgfputat{\pgfxy(5.8,6.8)}{$Point\; Cloud\; Data \; P(X_{f})$}}

  {\pgfputat{\pgfxy(0.6,-1.7)}{$Frequency\; Bands$}}

  {\pgfputat{\pgfxy(4.7,-1.7)}{$1rst\; Homology\; Level$}}
  {\pgfputat{\pgfxy(8.6,-1.7)}{$2nd\; Homology\; Level$}}
\end{pgfpicture} 
\end{frame}"""

textstringInit = """\documentclass[smaller,compress]{beamer}

\usepackage{tikz}
\usetikzlibrary{matrix,arrows,calc}

\setbeamertemplate{navigation symbols}{}
\setbeamertemplate{footline}[page number]{}
\setbeamercovered{transparent}

\\begin{document}"""


text_file = open("simulation2aN.tex", "w")
# text_file.write(textstringInit)
text_file.write("\n\n")

# us = 0.0; up = 60 - 10; 
# for kk in range(10,60):
nstep = 2; nfiles = 200; 
us = 0.0; up = nfiles - 100; 
for kk in range(100,nfiles,nstep):

    tt1 = "freqBandsManifold10"
    tt2 = "freqBandsManifold" + str(kk)
    newText = re.sub(tt1,tt2,textstring)

    tt1 = "tr2File10PersPlot1"
    tt2 = "tr2File" + str(kk) + "PersPlot1"
    newText = re.sub(tt1,tt2,newText)

    tt1 = "tr2File10PersPlot2"
    tt2 = "tr2File" + str(kk) + "PersPlot2"
    newText = re.sub(tt1,tt2,newText)

    tt1 = "sim1"
    tt2 = "./plotsData"
    newText = re.sub(tt1,tt2,newText)

    tt1 = "sim2"
    tt2 = "./results"
    newText = re.sub(tt1,tt2,newText)

    tk1 = "xfj"
    usp = us/up; usp = (kk-100.0)/(nfiles-100.0);
    tk2 = str("%.2f" % usp)
    newText = re.sub(tk1,tk2,newText)
    us = us +1

    text_file.write("\n")
    text_file.write(newText)
    text_file.write("\n")

text_file.write("\n")
# text_file.write("\end{document}")

text_file.close()


## s = "start foo end"
## >>> s = re.sub("foo", "replaced", s)
## >>> s
## 'start replaced end'
## 
## #print "Creating a text file with the write() method."
## text_file = open("write_it.txt", "w")
## 
## 
## text_file.write("Line 1\n")
## text_file.write("This is line 2\n")
## text_file.write("That makes this line 3\n")
## text_file.close()
