function topDistFourier()
% topological distortion

clear all; close all;

% ===================================
% swiss roll example manifold
N = 100; 
tt = linspace(3*pi/2,9*pi/2,N);
he = (sin(tt*110)+1)/10+0.5;
sed = [tt.*cos(tt)/20+0.8; he; tt.*sin(tt)/20+0.8]'; 

ncolors = 64; 
lse1 = size(sed,1); ncolorsArray = floor(([1:lse1-1]/lse1)*ncolors+1);
ncolorsArray(length(ncolorsArray)+1) = ncolorsArray(length(ncolorsArray));
% figure; trsed  = pcaAnalysis2(sed,ncolorsArray,1);  view([1,1,1]);

sedRaw = [tt; he]'; % original parameter space 
% figure; pcaAnalysis2(sedRaw,ncolorsArray,1);

%% =================================================
%% =================================================
% [seds2 seds] = doubleTorus(); 
[seds2 seds] = torus();
% [seds seds2] = torus();
% [sedk sedk2] = torus();
% seds2 = flipud(seds2);

psA = [100 100 392 294];
% figure('Position',psA); [trsed2 tsed2 dsed2] = pcaAnalysis2(seds2,ncolorsArray,1); view([1,1,1]); rotate3d on;
% figure('Position',psA); [trsed tsed dsed]   = pcaAnalysis2(seds,ncolorsArray,1); view([1,1,1]); rotate3d on;
% figure; pcaAnalysis2(sedRaws2,ncolorsArray,1);

%seds3 = seds2+seds;
%figure('Position',psA); [trsed3 dsed3]   = pcaAnalysis2(seds3,ncolorsArray,1); view([1,1,1]); rotate3d on;

% figure('Position',psA); trsed2  = pcaAnalysis2(sedk2,ncolorsArray,1); view([1,1,1]); rotate3d on;
% figure('Position',psA); trsed   = pcaAnalysis2(sedk,ncolorsArray,1); view([1,1,1]); rotate3d on;
% disp('fd3'); keyboard; 

L = 1; nn = 4*64;
x = linspace(0,L,nn)';

%% Signal Manifold: Modulation 1 
%% =================================================
% mM = 50; mN = 40; sedp = seds*(mM-mN)+mN; 
mM = 0.8; mN = 0; sedp = seds*(mM-mN)+mN; 

lij = 10;
intt1 = repmat(sedp(:,1)',length(x),1);
fa1 = exp(2*pi*i*(intt1+lij).*repmat((x-0.3),1,length(seds(:,1))))'; 
intt2 = repmat(sedp(:,2)',length(x),1);
fa2 = exp(2*pi*i*(intt2+lij+10).*repmat((x-0.5),1,length(seds(:,2))))'; 
intt3 = repmat(sedp(:,3)',length(x),1);
fa3 = exp(2*pi*i*(intt3+lij+20).*repmat((x-0.8),1,length(seds(:,3))))'; 

% fa1 = real(fa1); fa2 = real(fa2); fa3 = real(fa3);
fa = real(fa1+fa2+fa3);

% figure('Position',psA); [trfa tfa dfa] = pcaAnalysis2(fa,ncolorsArray,1); title('ftorus1'); rotate3d on; view(3);

%% Signal Manifold: Modulation 2 
%% =================================================
mM = 0.3; mN = 0; sedp2 = seds2*(mM-mN)+mN; 

lki = 40;
intt = repmat(sedp2(:,1)',length(x),1);
fb1 = exp(2*pi*i*(intt+lki).*repmat((x-0.1),1,length(seds2(:,1))))'; 
intt = repmat(sedp2(:,2)',length(x),1);
fb2 = exp(2*pi*i*(intt+lki+10).*repmat((x-0.3),1,length(seds2(:,2))))'; 
intt = repmat(sedp2(:,3)',length(x),1);
fb3 = exp(2*pi*i*(intt+lki+20).*repmat((x-0.8),1,length(seds2(:,3))))'; 

% fb1 = real(fb1); fb2 = real(fb2); fb3 = real(fb3);
fb = real(fb1 + fb2 + fb3); 

%figure('Position',psA); [trfb tfb dfb] = pcaAnalysis2(fb,ncolorsArray,1); title('ftorus2'); rotate3d on; view(3); 

fc = fa + fb*0.9;
%figure('Position',psA); [trfc tfc dfc] = pcaAnalysis2(fc,ncolorsArray,1); title('ftorus12'); rotate3d on; view(3);

%%== ffa = stftM(fa,nn,nn);  
%%== ffb = stftM(fb,nn,nn);  
%%== ffc = stftM(fc,nn,nn);  
%%== 
%%== psB = [100 100 392 494];
%%== %% figure('Position',psB); 
%%== %% subplot(311); imagesc(log10(abs(ffa(:,1:80)')));
%%== %% subplot(312); imagesc(log10(abs(ffb(:,1:80)')));
%%== %% subplot(313); imagesc(log10(abs(ffc(:,1:80)')));
%%== 
%%== figure('Position',psB); uk1 = 100;
%%== subplot(311); plot(abs(ffa(uk1,1:80))); grid; 
%%== subplot(312); plot(abs(ffb(uk1,1:80))); grid; 
%%== subplot(313); plot(abs(ffc(uk1,1:80))); grid; 

%% figure('Position',psA); [trfc tffc dffc] = pcaAnalysis2((real(ffc)),ncolorsArray,1); title('ffc'); rotate3d on; view(3);
%% figure('Position',psA); [trfa tffa dffa] = pcaAnalysis2((abs(ffa)),ncolorsArray,1); title('ffa'); rotate3d on; view(3);
%% figure('Position',psA); [trfb tffb dffb] = pcaAnalysis2((abs(ffb)),ncolorsArray,1); title('ffb'); rotate3d on; view(3); 
%

maniFiltering2(fa,fb); 
% maniFiltering3(fa1,fa2,fa3,fb1,fb2,fb3); 
% maniFiltering4(fa1,fa2,fa3,fb1,fb2,fb3); 

disp('sdf'); keyboard; 

